function GameConnection::VehicleSelect(%c)
{
   %d=0;
   commandToClient(%c,'setWrenchData',"N _Select_A_Vehicle_To_Spawn\tVDB "@%d@"\tRCV 1\tRC 1\tC 1\tR 1");
   commandToClient(%c,'openWrenchVehicleSpawnDlg',"Vehicle Selection",1);
   (%p=%c.player).pickingVehicle=1;
   %p.schedule(20000,0,eval,%p@".pickingVehicle=0;");
}
function servercmdSpawnVehicle(%c)
{
   if(isObject(%c.player))
      %c.VehicleSelect();
}
function Player::spawnVehicle(%p,%d)
{
   %z=%p.getTransform();
   %pos = vectorAdd(getWords(%z,0,3),"0 0 0.3");
   %rot = getWords(%z,3,8);
   if(isObject(%p.spawnedVehicle))
      %p.dismount();
   %v = new WheeledVehicle()
   {
      datablock = %d.getName();
      initialposition = %p.getPosition();
      client = %p.client;
      scale = "1 1 1";
      isSpawnedVehicle=1;
      owner=%p;
   };
   %p.spawnedVehicle=%d;
   MissionCleanup.add(%v);
   %v.setTransform(%pos SPC %rot);
   %v.setNodeColor("ALL",%p.getNiceColor(%v));
   %v.mountObject(%p,0);
}
function sinWaveColor(%i)
{
   %f=0.1;
   return (mSin(%i*%f+0)+1)/2 SPC (mSin(%i*%f+2)+1)/2 SPC (mSin(%i*%f+4)+1)/2 SPC 1;
}
function WheeledVehicle::sinWaveLoop(%t)
{
   cancel(%t.sinLoop);
   %t.setNodeColor("ALL",sinWaveColor(%t.sins++));
   %t.sinLoop=%t.schedule(16,sinWaveLoop);
}
function Player::getNiceColor(%p,%v)
{
   if(%p.currSprayCan!=-1)
      return getColorIDTable(%p.currSprayCan);
   else if(%p.currFXCan == 6)
   {
      %v.sinWaveLoop();
      return sinWaveColor(0);
   }
   else
      return "1 1 1 1";
}
if(isPackage(VehicleSpawn)) deactivatepackage(VehicleSpawn);
package VehicleSpawn
{
   function serverCmdSetWrenchData(%c,%d)
   {
      if(%c.player.pickingVehicle && isObject(%p=%c.player))
      {
         %k=getWord(getField(%d,1),1);
         if(%k.getClassName() $= "WheeledVehicleData" && %k!=0)
            %p.spawnVehicle(%k);
         %p.pickingVehicle=0;
      }
      else
         Parent::servercmdSetWrenchData(%c,%d);
   }
   function WheeledVehicle::onDriverLeave(%this,%p)
   {
      Parent::onDriverLeave(%this,%p);
      if(%this.isSpawnedVehicle)
      {
         %this.setTransform("0 0 -9999");
         %this.schedule(10,delete);
      }
   }
};
activatepackage(VehicleSpawn);